/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2020  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.simulator.execute;

import de.steamwar.bausystem.features.tracer.TraceRecorder;
import de.steamwar.bausystem.region.flags.ColorMode;
import de.steamwar.bausystem.region.flags.Flag;
import de.steamwar.bausystem.region.utils.RegionExtensionType;
import de.steamwar.bausystem.region.utils.RegionType;
import de.steamwar.bausystem.utils.PasteBuilder;
import de.steamwar.bausystem.utils.bossbar.BauSystemBossbar;

public class StabFinalizer extends StabStep {

    public StabFinalizer(StabData data) {
        super(data);
    }

    @Override
    protected void start() {
        try {
            PasteBuilder.ClipboardProvider clipboardProvider = new PasteBuilder.ClipboardProviderImpl(data.clipboard);
            PasteBuilder pasteBuilder = new PasteBuilder(clipboardProvider);
            if (data.region.hasFlag(Flag.COLOR).isReadable()) {
                pasteBuilder.color(data.region.getFlag(Flag.COLOR).get().getColor());
            }
            data.region.reset(pasteBuilder, RegionType.TESTBLOCK, RegionExtensionType.EXTENSION);
        } catch (SecurityException e) {
            stop();
            throw e;
        }

        TraceRecorder.instance.startRecording(data.region);
        runSimulator(() -> {
            TraceRecorder.instance.stopRecording(data.region);
            stop();
        });
    }

    @Override
    protected void bossbar(BauSystemBossbar bossbar, boolean stopped) {
        bossbar.setProgress(Math.min(data.currentDepth / (double) data.depthLimit, 1.0));
        bossbar.setTitle("§e" + data.currentDepth + "§8/§7" + data.depthLimit);
    }
}
